import { Path } from '../path';
import { ReadState } from '../state';
import { DeclareChildFeatures, Token, TokenExtension, _childFeatures } from '../token';
declare const _errorToken: unique symbol;
export interface ErrorsState {
    [path: string]: string;
}
export interface Error<TState = any> extends Path<TState> {
    readonly [_errorToken]: ReadState<string>;
    [_childFeatures]?: DeclareChildFeatures<Path<TState>, 'error', {
        [P in keyof NonNullable<TState>]-?: Error<NonNullable<TState>[P]>;
    }>;
}
export interface ErrorOptions {
    errorsToken: Token<ReadState<ErrorsState>>;
}
export declare function addError<TState = any>(options: ErrorOptions): TokenExtension<Path<TState>, Error<TState>>;
export declare function getTokenError(token: Error): string | undefined;
export declare function useTokenError(token: Error): string | undefined;
export {};
