import { SchemaOf } from 'yup';
import { State } from '../state';
import { DeclareChildFeatures, Token, TokenExtension, _childFeatures } from '../token';
import { Schema } from './schema';
import { Validated } from './validation';
export interface FormState<TReadState, TWriteState = TReadState> extends State<TReadState, TWriteState>, Validated<TReadState>, Schema<TReadState> {
    [_childFeatures]?: DeclareChildFeatures<State<TReadState, TWriteState> & Validated<TReadState> & Schema<TReadState>, 'formState', {
        [P in keyof NonNullable<TReadState> & keyof NonNullable<TWriteState>]-?: FormState<NonNullable<TReadState>[P] | (TReadState extends null | undefined ? undefined : never), NonNullable<TWriteState>[P]>;
    }>;
}
export interface FormOptions<TState> {
    schema: SchemaOf<TState>;
    debounceValidationMs?: number;
}
export declare function addForm<TState>(options: FormOptions<TState>): TokenExtension<State<TState>, FormState<TState>>;
export declare function useFormToken<TState>(options: FormOptions<TState>): Token<FormState<TState>>;
