import { SchemaOf } from 'yup';
import { DeclareChildFeatures, NoFeature, TokenExtension, _childFeatures } from '../token';
declare const _schema: unique symbol;
export interface Schema<TState> {
    readonly [_schema]: SchemaOf<TState>;
    [_childFeatures]?: DeclareChildFeatures<NoFeature, 'schema', {
        [P in keyof NonNullable<TState>]-?: Schema<NonNullable<TState>[P]>;
    }>;
}
export declare function addSchema<TState>(schema: SchemaOf<TState>): TokenExtension<NoFeature, Schema<TState>>;
export declare function getTokenSchema<T>(token: Schema<T>): SchemaOf<T>;
export interface SchemaInfo {
    label?: string;
    required?: boolean;
}
export declare function useTokenSchemaInfo(token: Schema<unknown>): SchemaInfo;
export {};
