declare const _children: unique symbol;
declare const _childrenInterceptor: unique symbol;
export declare const _childFeatures: unique symbol;
interface TokenBase {
    [_children]?: Record<PropertyKey, any>;
    [_childrenInterceptor]: ChildTokenInterceptor;
}
export interface NoFeature {
    [_childFeatures]?: DeclareChildFeatures<undefined, 'noFeature', {
        [P in PropertyKey]: NoFeature;
    }>;
}
export declare type Token<Features> = TokenBase & Features & {
    [P in ChildProperties<Features>]: Token<ChildFeatures<Features, P>>;
};
export declare function createToken<Features = NoFeature>(extension?: TokenExtension<NoFeature, Features>): Token<Features>;
export declare function extendToken<CurrentFeatures extends BaseFeature, NewFature, BaseFeature = CurrentFeatures>(token: Token<CurrentFeatures>, extension: TokenExtension<BaseFeature, NewFature>): Token<NewFature extends CurrentFeatures ? NewFature : CurrentFeatures & NewFature>;
export declare type TokenExtension<BaseFeatures, NewFeatures> = {
    extend: Omit<NewFeatures, keyof BaseFeatures>;
    extendChildren?: boolean | ((token: Token<BaseFeatures>, parentToken: Token<BaseFeatures & NewFeatures>, property: PropertyKey) => Omit<NewFeatures, keyof BaseFeatures>);
} | ((token: Token<BaseFeatures>) => Token<NewFeatures extends BaseFeatures ? NewFeatures : BaseFeatures & NewFeatures>);
export declare type ChildFeatures<Features, Property extends PropertyKey> = UnionToIntersection<Features extends {
    [C in typeof _childFeatures]?: {
        [I in string]?: {
            [P in Property]: infer T;
        };
    };
} ? T : {}>;
export declare type ChildProperties<Features> = Features extends {
    [K in typeof _childFeatures]?: {
        [i in string]?: infer T;
    };
} ? keyof NonNullable<T> : never;
export declare type DeclareChildFeatures<OmitFeatures, UniqueIdentifier extends string, ChildFeatures> = (OmitFeatures extends {
    [K in typeof _childFeatures]?: infer T;
} ? {
    [P in keyof T]: never;
} : {}) & {
    [P in UniqueIdentifier]?: ChildFeatures;
};
declare type ChildTokenInterceptor = (token: any, parentToken: any, property: PropertyKey) => any;
declare type UnionToIntersection<T> = (T extends any ? (x: T) => any : never) extends (x: infer R) => any ? R : never;
export declare function useToken<Feature = NoFeature>(extensionFactory?: () => TokenExtension<NoFeature, Feature>): Token<Feature>;
export declare function useTokenExtension<CurrentFeatures extends BaseFeatures, NewFeatures, BaseFeatures = CurrentFeatures>(token: Token<CurrentFeatures>, extensionFactory: () => TokenExtension<BaseFeatures, NewFeatures>): Token<NewFeatures extends CurrentFeatures ? NewFeatures : CurrentFeatures & NewFeatures>;
export {};
